unit uIRDevice;

interface
uses  Windows, Classes, Messages, SysUtils, StrUtils, Forms, uVAR, HidControllerClass;
//Komponente HIDControllerClass von Robert Marquardt
//Information unter www.delphi-jedi.org

function OpenIRDevice(): longint;
Procedure CloseIRDevice();

Type
  TIrCintrollerThread = class(TThread)
  private
    Dev:          TJvHidDevice;
    DevIndex:     Integer;
    Data:         TReport;
    InAction:     Boolean;
  public
    procedure Execute; override;
    procedure HandleData;
  end;

  TIRDevice  = class(TObject)
    HidDeviceController: TJvHidDeviceController;
    procedure HidDeviceChange(Sender: TObject);
  private
    { Private-Deklarationen }
    InAction:         Boolean;
    DevList:          TList;
    Constructor Create();
    Destructor  Destroy(); override;
  end;

type
  TShiftKeyInfo = record
    shift: Byte;
    key: Byte;
  end;
  byteset = set of 0..7;

const
  shiftkeys: array [1..3] of TShiftKeyInfo =  ( (shift: Ord(ssCtrl);  key: VK_CONTROL),
                                                (shift: Ord(ssShift); key: VK_SHIFT),
                                                (shift: Ord(ssAlt);   key: VK_MENU));
var
  oIRDevice:  TIRDevice;
  DeviceTrd:  TIrCintrollerThread;
  HidDev:     TJvHidDevice;
  BytesRead:  DWORD;
  SendHwnd:   integer = 0;
  KeybordHwnd: integer = 0;
  LostStick:  boolean = false;

implementation
uses uKeyboard;
{-------------- Synchronize(HandleData) auswerten  ----------------------------}
procedure TIrCintrollerThread.HandleData;
var
  i:              integer;
  flag:           DWORD;
  key:            Word;
  aChar:          char;
  KeyCodeArray:   TStringList;
  KeyCodeString:  string;
  shift:          TShiftState;
  bShift:         ByteSet absolute shift;
begin
  key := 0;
  //IR-Signale von anderen Gerten ignorieren
  if (data.Bytes[1] <> 247) and (data.Bytes[3] <> (255 - data.Bytes[2])) then
    exit;
  //Thread-Auswertung sperren bis wir fertig sind
  if InAction then exit;
  InAction := true;

  try
    //Keybord anzeigen
    if data.Bytes[2] = GetKeyCode('IrDVD') then
    begin
      if not frmKeyboard.Shown then
        frmKeyboard.Show();
      InAction := False;
      exit;
    end;
    if frmKeyboard.Shown then //alle Tasten zum Keybord schicken
    begin
      frmKeyboard.KeyBoardMessage(data.Bytes[2]);
      InAction := False;
      exit;
    end;
    //goto StandbyMode
    if data.Bytes[2] = GetKeyCode('IrExit') then
    begin
      ForceSuspend();
      InAction := False;
      exit;
    end;
    (**************************************************************************)
    (*** Player-Start und Handle holen bzw. berprfen ************************)
    (**************************************************************************)
    //startet jemand expliziert den Player?
    if data.Bytes[2] = GetKeyCode('IrMusik') then begin
      //den Player starten, wenn er nicht schon luft
      //HWND vom aktiven Mediaplayer holen
      SendHwnd := FindWindow(nil, PChar(ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), 'WindowCaption', '', Inifile, false )));
      if SendHwnd = 0 then begin
        //noch nicht da, starten
        ExecNewProcessWithParam(ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), 'FilePath', '', Inifile, false ));
        Wait(4000);//4 Sekunden warten
        //HWND vom aktiven Mediaplayer holen
        SendHwnd := FindWindow(nil, PChar(ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), 'WindowCaption', '', Inifile, false )));
      end;
      InAction := False;
      exit;
    end;
    //gltiges Handle da?
    SendHwnd := FindWindow(nil, PChar(ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), 'WindowCaption', '', Inifile, false )));
    if SendHwnd = 0 then begin
      //Player starten
      ExecNewProcessWithParam(ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), 'FilePath', '', Inifile, false ));
      Wait(4000);//4 Sekunden warten
      SendHwnd := FindWindow(nil, PChar(ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), 'WindowCaption', '', Inifile, false )));
      if SendHwnd = 0 then begin
        //irgenwie bekommen wir kein Handle
        Beep(); Wait(50); Beep(); Wait(50);Beep();
        InAction := False;
        exit;
      end;
    end;
    (**************************************************************************)
    (******************** Tasten auswerten ************************************)
    (**************************************************************************)
    //zugehrige Tasten aus Inifile holen
    KeyCodeString := ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), IntToStr(data.Bytes[2]), '', Inifile, false );
    KeyCodeArray := Split(KeyCodeString, '-');
    //shiftStati analysieren
    if KeyCodeArray[0] = '1' then
      shift := [ssCtrl];
    if KeyCodeArray[1] = '1' then
      shift := shift + [ssShift];
    if KeyCodeArray[2] = '1' then
      shift := shift + [ssAlt];
    if KeyCodeArray[3] <> '' then
    begin //Buchstabe oder Zahl
      try
        key := StrToInt(KeyCodeArray[3]);
      except
        aChar := KeyCodeArray[3][1];
        key := Ord(aChar);
      end;
    end;
    //Fenster aktivieren
    SetForegroundWindow(SendHwnd);
    SetActiveWindow(SendHwnd); //
    Wait(50);
    //ShiftTasten senden
    for i := 1 to 3 do
    begin
      if shiftkeys[i].shift in bShift then
        keybd_event(shiftkeys[i].key, MapVirtualKey(shiftkeys[i].key, 0), 0, 0);
    end;
    //Taste senden
    flag := 0;
    keybd_event(key, MapvirtualKey(key, 0), flag, 0);
    flag := flag or KEYEVENTF_KEYUP;
    keybd_event(key, MapvirtualKey(key, 0), flag, 0);
    //ShiftTasten loslassen
    for i := 3 downto 1 do
    begin
      if shiftkeys[i].shift in bShift then
        keybd_event(shiftkeys[i].key, MapVirtualKey(shiftkeys[i].key, 0), KEYEVENTF_KEYUP, 0);
    end;
  except
    Beep();
  end;
  InAction := False;
end;
{------------------- unser aktiver Thread -------------------------------------}
procedure TIrCintrollerThread.Execute;
var
  SleepRet: DWORD;
  procedure Dummy(ErrorCode: DWORD; Count: DWORD;
    Ovl: POverlapped); stdcall;
  begin
  end;
begin
  while not Terminated do
  begin
    if not Dev.ReadFileEx(Data, Dev.Caps.InputReportByteLength, @Dummy) then // lesen Daten
      Break;
    repeat //warten bis lesen komplett
      SleepRet := SleepEx(50, True);
      if LostStick then Terminate();
    until Terminated or (SleepRet = WAIT_IO_COMPLETION);
    if not Terminated then
    begin
      Synchronize(HandleData);//auswerten
    end;
  end;
  begin
    try
      Dev.CloseFileEx(omRead);
      if (Dev.HIDOverlappedread <> INVALID_HANDLE_VALUE) then
        Windows.CancelIO(Dev.HIDOverlappedread);
    finally
      try
        Dev.Free();
      finally
        Dev := nil;
        //Falls jemand den Stick gezogen hat
        LostStick := true;
      end;
    end;
  end;
end;
{----------------------- DeviceChange -----------------------------------------}
procedure TIRDevice.HidDeviceChange(Sender: TObject);
begin
  if DevList = nil then begin
    DevList := TList.Create;
    DevList.Clear;
  end;
  while HidDeviceController.CheckOutByClass(HidDev, cHidNoClass) do// keine mouse und Tastatur
  begin
    if ( (HidDev.Attributes.VendorID = GetVendorID) and (HidDev.Attributes.ProductID = GetProductID) ) then
    begin//HID Stick-angeschlossen
      DeviceTrd := TIrCintrollerThread.Create(True);//Create Thread
      with DeviceTrd do
      begin
        FreeOnTerminate := True;
        Dev := HidDev;
        DevIndex := DevList.Count;
        DevList.Add(DeviceTrd);
        Resume;//thread run
        break;
      end;{with do}
    end;{if}
  end;{while}
end;{DeviceChange}
{----------------- Constructor ------------------------------------------------}
Constructor TIRDevice.Create();
begin
  InAction := False;
  HidDeviceController := TJvHidDeviceController.Create(nil) ;
  HidDeviceController.OnDeviceChange := HidDeviceChange;
end;
{----------------- Destructor -------------------------------------------------}
Destructor TIRDevice.Destroy;
begin
  HidDeviceController.Free;
  if assigned(DevList) then DevList.Clear;
end;
{----------------- Gert suchen und initialisieren ----------------------------}
function OpenIRDevice(): longint;
begin
  try
    LostStick := false;
    oIRDevice := TIRDevice.Create();//unser Objekt
    if oIRDevice.DevList.Count > 0 then begin
      Result := 0;// Alles OK
    end else begin
      if assigned(oIRDevice) then oIRDevice.Free;
      oIRDevice:= nil;
      Result := 1;
      LostStick := true;
      exit;
    end;
  except
    on E: Exception do begin
      if assigned(oIRDevice) then oIRDevice.Free;
      oIRDevice := nil;
      Result := 2;
      LostStick := true;
      exit;
    end;
  end;
end;
{---------------- Object beenden, schlieen und  freigeben --------------------}
Procedure CloseIRDevice();
begin
  if  not assigned(oIRDevice)then exit;
  try
    if oIRDevice.DevList.Count > 0 then begin
      DeviceTrd.Terminate;
      LetOtherRunToo();
    end;
  finally
    oIRDevice.Free;
    oIRDevice := nil;
  end;
end;
{------------------------------------------------------------------------------}
end.


