unit uKeyboard;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, uVar;

  function GetSearchWindow(Wnd: HWnd; param: lParam): boolean; stdcall;
  function GetSearchResultWindow(Wnd: HWnd; param: lParam): boolean; stdcall;

type
  TfrmKeyboard = class(TForm)
    KeySelect: TShape;
    tmrBringFront: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure ButtonEnter(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tmrBringFrontTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure KeyBoardMessage(Key: Byte);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Shown: boolean;
    lastKey: Integer;
  end;

var
  frmKeyboard: TfrmKeyboard;

implementation

{$R *.dfm}
type
  TNeighborButtons = record
    left  : integer;
    right : integer;
    up    : integer;
    down  : integer;
  end;

const
  ButtonCount = 38;
  NeighborArray: Array[0..ButtonCount - 1] of TNeighborButtons = ((up:-1; down:11),
                                                                  (up:-1; down:12),
                                                                  (up:-1; down:13),
                                                                  (up:-1; down:14),
                                                                  (up:-1; down:15),
                                                                  (up:-1; down:16),
                                                                  (up:-1; down:17),
                                                                  (up:-1; down:18),
                                                                  (up:-1; down:19),
                                                                  (up:-1; down:20),
                                                                  (up:-1; down:20),
                                                                  //2.Reihe
                                                                  (up:0; down:21),
                                                                  (up:1; down:22),
                                                                  (up:2; down:23),
                                                                  (up:3; down:24),
                                                                  (up:4; down:25),
                                                                  (up:5; down:26),
                                                                  (up:6; down:27),
                                                                  (up:7; down:28),
                                                                  (up:8; down:29),
                                                                  (up:9; down:29),
                                                                  //3.Reihe
                                                                  (up:11; down:30),
                                                                  (up:12; down:30),
                                                                  (up:13; down:31),
                                                                  (up:14; down:32),
                                                                  (up:15; down:33),
                                                                  (up:16; down:34),
                                                                  (up:17; down:35),
                                                                  (up:18; down:36),
                                                                  (up:19; down:36),
                                                                  //4. Reihe
                                                                  (up:22; down:37),
                                                                  (up:23; down:37),
                                                                  (up:24; down:37),
                                                                  (up:25; down:37),
                                                                  (up:26; down:37),
                                                                  (up:27; down:37),
                                                                  (up:28; down:37),
                                                                  //5.Reihe
                                                                  (up:33; down:-1));

var
  gblSendedKeyString: string = '';
  MPSearchHWND, MPSearchResultHWND: Hwnd;
  ButtonArray: Array[0..ButtonCount - 1] of TButton;
  ButtonCaptions: Array[0..ButtonCount - 1]of string = ('0','1','2','3','4','5','6','7','8','9', '<--',
                                                          'Q','W','E','R','T','Z','U','I','O','P',
                                                            'A','S','D','F','G','H','J','K','L',
                                                                'Y','X','C','V','B','N','M',
                                                                          ' ') ;

{------------------- FormCreate -----------------------------------------------}
procedure TfrmKeyboard.FormCreate(Sender: TObject);
var
  i, Row: integer;
begin
  Shown := false;
  // Tasten der Tastatur hier dynamisch anlegen
  for i := 0 to ButtonCount - 1 do
  begin
    ButtonArray[i] := TButton.Create(Self);
    case i of
      0..10:  Row := 0;
      11..20: Row := 1;
      21..29: Row := 2;
      30..36: Row := 3;
    else      Row := 4;
    end;
    with ButtonArray[i] do
    begin
      Parent  := self;
      Caption := ButtonCaptions[i];
      Width   := 25;
      Height  := 25;
      Top	    := 10 + ((Row * (Height + 3)));
      case row of
        0:  Left := ((i - (row * 10))  * 28) + 30;
        1:  Left := ((i - (row * 10))  * 28) + 15;
        2:  Left := ((i - (row * 10))  * 28) + 31;
        3:  Left := ((i - (row * 10))  * 28) + 87;
        4:  Left := ((i - (row * 10))  * 28) + 172;
      end;
      Tag	    := i;
      OnEnter := ButtonEnter;
      ButtonArray[i].Font.Style := [fsbold];
      ButtonArray[i].Font.Size := 10;
   end;
  end;//for
  ButtonArray[37].Width := 192;//Space-Taste
  //Gre der Form festlegen
  Height := 190;
  Width := 370;
end;
{------------------- ButtonEnter-----------------------------------------------}
procedure TfrmKeyboard.ButtonEnter(Sender: TObject);
begin
  //ausgewhlte Taste rot hinterlegen
  KeySelect.Height := (Sender as TButton).Height + 4;
  KeySelect.Width := (Sender as TButton).Width + 4;
  KeySelect.Top := (Sender as TButton).Top - 2;
  KeySelect.Left := (Sender as TButton).Left - 2;
  lastKey := (Sender as TButton).Tag;
end;
{------------------- FormClose ------------------------------------------------}
procedure TfrmKeyboard.FormClose(Sender: TObject; var Action: TCloseAction);
var
  MainWindowHwnd: HWND;//z.B. MediaMonkey Hauptfenster
  flag: DWORD;
begin
  tmrBringFront.Enabled := false;
  Shown := false;
  //HWND vom aktiven Mediaplayer holen
  MainWindowHwnd := FindWindow(nil, PChar(ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), 'WindowCaption', '', Inifile, false )));
  //den Focus ins Ergebnisfenster setzen
  EnumChildWindows(MainWindowHwnd, @GetSearchResultWindow, 42);
  //Ergebnisfenster aktivieren
  SetForegroundWindow(MPSearchResultHWND);
  Wait(50);
  //TAB-Taste senden
  flag := 0;
  keybd_event(VK_TAB, MapvirtualKey(VK_TAB, 0), flag, 0);
  flag := flag or KEYEVENTF_KEYUP;
  keybd_event(VK_TAB, MapvirtualKey(VK_TAB, 0), flag, 0);
  //So jetzt sollten wir den ersten Eintrag im Ergebnisfenster ausgewhlt haben
end;
{------------------- BringFront -----------------------------------------------}
procedure TfrmKeyboard.tmrBringFrontTimer(Sender: TObject);
begin
  SetForegroundWindow(self.Handle);
end;
{------------------- FormShow -------------------------------------------------}
procedure TfrmKeyboard.FormShow(Sender: TObject);
begin
  ButtonArray[25].SetFocus;//"G" vorselektieren
  tmrBringFront.Enabled := true;
  Shown := true;
  gblSendedKeyString := '';
  self.Top := (screen.Height div 4) * 3 - 20;
  self.Left := (screen.Width div 3) * 2;
end;
{------------------- KeyBoardMessage ------------------------------------------}
procedure TfrmKeyboard.KeyBoardMessage(Key: Byte);
var
  MainWindowHwnd: HWND;
  flag: DWORD;
  SendedKey: Word;
  i: integer;
begin
  if key = GetKeyCode('IrArrowDown') then
  //------------------ Pfeil nach runter -------------------------------------
  begin
    if NeighborArray[lastKey].down  <> -1 then  ButtonArray[NeighborArray[lastKey].down].SetFocus;
  end
  //------------------ Pfeil nach oben ---------------------------------------
  else if key = GetKeyCode('IrArrowUp') then
  begin
    if NeighborArray[lastKey].up  <> -1 then  ButtonArray[NeighborArray[lastKey].up].SetFocus;
  end
  //------------------ Pfeil nach rechts -------------------------------------
  else if key = GetKeyCode('IrArrowRight') then
  begin
    if lastKey < 36 then
      ButtonArray[lastKey + 1].SetFocus
    else
      ButtonArray[0].SetFocus
  end
  //------------------ Pfeil nach links --------------------------------------
  else if key = GetKeyCode('IrArrowLeft') then
  begin
    if lastKey > 0 then
      ButtonArray[lastKey - 1].SetFocus
    else
      ButtonArray[36].SetFocus
  end
  //------------------ OK-Taste ----------------------------------------------
  else if key = GetKeyCode('IrOK') then
  begin
    //HWND vom aktiven Mediaplayer holen
    MainWindowHwnd := FindWindow(nil, PChar(ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), 'WindowCaption', '', Inifile, false )));
    //"Suchen"-Fenster ermitteln
    EnumChildWindows(MainWindowHwnd, @GetSearchWindow, 42);
    //Windowhandle ist nun in MPSearchHWND

    //Suchfenster aktivieren
    SetForegroundWindow(MPSearchHWND);
    SetActiveWindow(MPSearchHWND);
    Wait(50);
    //Buchstabe oder Bksp ausgewhlt?
    if ButtonArray[lastKey].Caption[1] = '<' then //Backspace?
    begin//Suchsting reduzieen
      if Length(gblSendedKeyString) > 0 then
        SetLength(gblSendedKeyString, Length(gblSendedKeyString) - 1);
    end else//Suchsting erweitern
      gblSendedKeyString := gblSendedKeyString + LowerCase(ButtonArray[lastKey].Caption[1]);

    //Zusatz fr "lsche letzt Taste"
    gblSendedKeyString := Trim(gblSendedKeyString);
    if gblSendedKeyString = '' then gblSendedKeyString := ' ';//letzte Zeichen lt sich nicht lschen

    //Tastencode buchstabenweise ins Suchfeld schicken
    for i := 1 to length(gblSendedKeyString) do
    begin
      SendedKey := Ord(gblSendedKeyString[i]);
      //Taste senden
      flag := 0;
      keybd_event(SendedKey, MapvirtualKey(SendedKey, 0), flag, 0);//Taste gedrckt
      SendMessage(MPSearchHWND, WM_CHAR, Ord(SendedKey),0);        //Tastencode schicken
      SendMessage(MPSearchHWND, WM_PAINT, 0, 0);
      flag := flag or KEYEVENTF_KEYUP;
      keybd_event(SendedKey, MapvirtualKey(SendedKey, 0), flag, 0);//Taste losgelassen
    end;
  end
  //------------------ ESC-Taste ---------------------------------------------
  else if key = GetKeyCode('IrESC') then
    Close(); //Tastatur schlieen

end;
{------- Callback fr EnumChildWindows zum Finden des Suchfeldes --------------}
function GetSearchWindow(Wnd: HWnd; param: lParam): boolean;//aka EnumWindowsProc
var
ClassName : Array[0..255] of Char;
begin
  GetClassname(Wnd, ClassName, 255);
  If ClassName = ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), 'ClassSearchWindow', '', Inifile, false ) then//Klasse des Suchfeldes
  begin
    MPSearchHWND := Wnd;
    Result := False;
  end else result := True;
end;
{-------- Callback fr EnumChildWindows zum Finden der Suchergebnisliste ------}
function GetSearchResultWindow(Wnd: HWnd; param: lParam): boolean;//aka EnumWindowsProc
var
ClassName : Array[0..255] of Char;
begin
  GetClassname(Wnd, ClassName, 255);
  If ClassName = ReadIniFile(ReadIniFile('General', 'ActiveProgram', '', Inifile, false), 'ClassSearchResultWindow ', '', Inifile, false ) then////Klasse der Suchergebnisliste
  begin
    MPSearchResultHWND := Wnd;
    Result := False;
  end else result := True;
end;
{------------------------------------------------------------------------------}

end.

