unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls, ShellAPI,
  Menus, ExtCtrls, uIRDevice, uVar, HidControllerClass;

type
  TMainform = class(TForm)
    tmrLife: TTimer;
    PopupMenu1: TPopupMenu;
    Exit1: TMenuItem;
    Info: TMenuItem;
    N1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExitClick(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure tmrLifeTimer(Sender: TObject);
  private
    { Private-Deklarationen }
    NotifyIconData: TNotifyIconData;
    procedure TaskbarEvent(var Message: TMessage); Message WM_TASKABAREVENT;
  public
    { Public-Deklarationen }
  end;

var
  Mainform: TMainform;

implementation

uses uInfo;
{$R *.dfm}
{------------Message-Prozedur fr das TrayIcon---------------------------------}
procedure TMainform.TaskbarEvent(var Message: TMessage);
var
  CursorPos : TPoint;
begin
  if Message.lParam = WM_RBUTTONDOWN then begin
    GetCursorPos(CursorPos);
    SetForegroundWindow(Handle);
    PopupMenu1.Popup(CursorPos.x, CursorPos.y - 20);
    PostMessage(Handle, WM_NULL, 0, 0);
  end else if Message.lParam = WM_LBUTTONDOWN then begin
    SetForegroundWindow(Handle);
    PostMessage(Handle, WM_NULL, 0, 0);
  end else
    inherited;
end;
{-----------------------FormCreate---------------------------------------------}
procedure TMainform.FormCreate(Sender: TObject);
var
  ProgrammString: string;
  i: integer;
begin
  //Taskbar Icon anlegen
  Fillchar(NotifyIconData, Sizeof(NotifyIconData), 0);
  NotifyIconData.cbSize := Sizeof(NotifyIconData);
  NotifyIconData.Wnd    := Handle;
  NotifyIconData.uFlags := NIF_MESSAGE
    or NIF_ICON
    or NIF_TIP;
  NotifyIconData.uCallbackMessage := WM_TASKABAREVENT;
  NotifyIconData.hIcon := Application.Icon.Handle;
  ProgrammString := 'IR Remote Control';
  for i := 0 to length(ProgrammString) - 1 do
    NotifyIconData.szTip[i] := ProgrammString[i+1];

  Shell_NotifyIcon(NIM_ADD, @NotifyIconData);
  //IR Adapter ffnen
  OpenIRDevice();
  Application.ShowMainForm := false;
  AppDir := ExtractFilePath(Application.ExeName);
  Inifile := AddDirSep(AppDir) + 'KeyDefs.ini';
end;
{-----------------------FormClose----------------------------------------------}
procedure TMainform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IR Adapter schlieen
  CloseIRDevice();
end;
{-----------------------Exit Click---------------------------------------------}
procedure TMainform.ExitClick(Sender: TObject);
begin
  //Taskbar Icon entfernen
  Shell_NotifyIcon(NIM_DELETE, @NotifyIconData);
  try
    Application.ProcessMessages;
  finally
    Close();
  end;
end;
{-----------------------Popup--------------------------------------------------}
procedure TMainform.PopupMenu1Popup(Sender: TObject);
begin
  SetForegroundWindow(PopupMenu1.Handle);
end;
{-----------------------InfoClick----------------------------------------------}
procedure TMainform.InfoClick(Sender: TObject);
begin
    AboutBox.ShowModal();
end;
{----------------------Timer Tick----------------------------------------------}
procedure TMainform.tmrLifeTimer(Sender: TObject);
begin
(* Timer schaut alle 5 Sekunden nach, ob der Stick noch da ist
  Hngt ihn wieder ein, wenn er weg war*)
  tmrLife.enabled := false;
  if LostStick = true then begin
    //IR Adapter schlieen
    CloseIRDevice();
    //IR Adapter wieder ffnen
    if OpenIRDevice() = 0 then
      LostStick := false;
  end;
  tmrLife.enabled := true;
end;
{------------------------------------------------------------------------------}

end.

