unit uVAR;

interface
uses sysutils, Messages, windows, classes, Inifiles, Forms, ShellAPI;

function ReadIniFile(section: string; entry: string; default: string; filename: string; LeerString2Null: boolean): string;
procedure LetOtherRunToo;
procedure Wait( Millisec: integer);
Function AddDirSep(sPath: String): string;
function Split(const Text: String; const Seperator: char): TStringList;
function ExecNewProcessWithParam(ProgramName : String):Longint;
function GetFileVersion: string;
Procedure ForceSuspend();
function GetVendorID(): integer;
function GetProductID(): integer;
function GetKeyCode(Value: string): integer;

const
  WM_TASKABAREVENT = WM_USER + 1; //Taskbar message

type
  TReport = packed record
    ReportID: Byte;
    Bytes: array [0..63] of Byte;
  end;

var
  AppDir, Inifile: string;

implementation
{------------------------------------------------------------------------------}
Procedure ForceSuspend();
begin
  ShellExecute(Application.Handle, 'open', 'rundll32.exe', PChar('powrprof.dll,SetSuspendState'), nil, SW_SHOWNORMAL);
end;
{------------------------------------------------------------------------------}
function GetFileVersion: string;
var
  VerInfoSize: DWORD;
  VerInfo: Pointer;
  VerValueSize: DWORD;
  VerValue: PVSFixedFileInfo;
  Dummy: DWORD;
begin
  VerInfoSize := GetFileVersionInfoSize(Pointer(Application.ExeName), Dummy);
  GetMem(VerInfo, VerInfoSize);

  GetFileVersionInfo(Pointer(Application.ExeName), 0, VerInfoSize, VerInfo);
  VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
  with VerValue^ do
  begin
    Result := IntToStr(dwFileVersionMS shr 16);
    Result := Result + '.' + IntToStr(dwFileVersionMS and $FFFF);
    Result := Result + '.' + IntToStr(dwFileVersionLS shr 16);
    Result := Result + '.' + IntToStr(dwFileVersionLS and $FFFF);
  end;
  FreeMem(VerInfo, VerInfoSize);
end;
{------------------------------------------------------------------------------}
procedure Wait(Millisec: integer);
var
  i: Integer;
begin
  for i := 0 to 5 do
  begin
    Sleep(Millisec div 5);
    LetOtherRunToo();
  end;
end;
{------------------------------------------------------------------------------}
procedure LetOtherRunToo;
var
  Msg: TMsg;
begin
  while PeekMessage(Msg, 0, 0, 0, PM_REMOVE) do begin
    TranslateMessage( Msg );
    DispatchMessage( Msg );
  end;
end;
{------------------------------------------------------------------------------}
function ReadIniFile(section: string; entry: string; default: string; filename: string; LeerString2Null: boolean): string;
var
	TempString: string;
begin
  with TIniFile.Create(filename) do
  try
    TempString := ReadString(section, entry, default);
    if LeerString2Null then
      if Trim(TempString) = '' then TempString := '0';
    result := TempString;
  finally
    Free;
  end;
end;
{------------------------------------------------------------------------------}
Function AddDirSep(sPath: String): string;
var
  cTemp: string;
begin
  cTemp := copy(sPath, length(sPath), 1);
  if cTemp <>  '\' then sPath := sPath + '\';
  Result := sPath;
end;
{------------------------------------------------------------------------------}
function Split(const Text: String; const Seperator: char): TStringList;
var
  i: Integer;
  Buffer: String;
begin
  Result := TStringList.Create;
  Buffer:='';
  for i := 1 to Length(Text) do
  begin
    if Text[i] = Seperator then
    begin
      if Buffer = '' then  Buffer := Seperator;
      if Buffer[1] = Seperator then
        Buffer := Copy(Buffer, 2, Length(Buffer));
      Result.Add(Buffer);
      Buffer := '';
    end;
    if Text[i] <> Seperator then
        Buffer := Buffer + Text[i];
  end;
  if Buffer<>'' then
    Result.Add(Buffer);
end;
{------------------------------------------------------------------------------}
function ExecNewProcessWithParam(ProgramName : String):Longint;
var
  StartInfo  : TStartupInfo;
  ProcInfo   : TProcessInformation;
  CreateOK   : Boolean;
begin

  { fill with known state }
  FillChar(StartInfo,SizeOf(TStartupInfo),#0);
  FillChar(ProcInfo,SizeOf(TProcessInformation),#0);
  StartInfo.cb := SizeOf(TStartupInfo);

  CreateOK := CreateProcess(nil, PChar(ProgramName), nil, nil,False,
              CREATE_NEW_PROCESS_GROUP+NORMAL_PRIORITY_CLASS,
              nil, nil, StartInfo, ProcInfo);

  if CreateOK then result:=0 else result:=1;
end;
{------------------------------------------------------------------------------}
function GetVendorID(): integer;
var
  ActiveRC: string;
begin
  ActiveRC := ReadIniFile('General', 'ActiveRC ', '', Inifile, false);
  Result := StrToInt(ReadIniFile(ActiveRC, 'VendorID', '', Inifile, false));
end;
{------------------------------------------------------------------------------}
function GetProductID(): integer;
var
  ActiveRC: string;
begin
  ActiveRC := ReadIniFile('General', 'ActiveRC', '', Inifile, false );
  Result := StrToInt(ReadIniFile(ActiveRC, 'ProductID', '', Inifile, false));
end;
{------------------------------------------------------------------------------}
function GetKeyCode(Value: string): integer;
var
  ActiveRC: string;
begin
  ActiveRC := ReadIniFile('General', 'ActiveRC', '', Inifile, false );
  Result := StrToInt(ReadIniFile(ActiveRC, Value, '', Inifile, false));
end;

{------------------------------------------------------------------------------}

end.
